// dialogtest.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "resource.h"

BOOL CALLBACK DialogProc(
  HWND hwndDlg,  // handle to dialog box
  UINT uMsg,     // message
  WPARAM wParam, // first message parameter
  LPARAM lParam  // second message parameter
);

#ifdef _DEBUG
#define DBGSTR(a) OutputDebugString(a);
#define DBGSTR1(a,b) {TCHAR buffer[80]; wsprintf ( buffer, a, b ); OutputDebugString(buffer);}
#define DBGSTR2(a,b,c) {TCHAR buffer[80]; wsprintf ( buffer, a, b,c ); OutputDebugString(buffer);}
#define DBGSTR3(a,b,c,d) {TCHAR buffer[80]; wsprintf ( buffer, a, b,c,d ); OutputDebugString(buffer);}
#else
#define DBGSTR(a)
#define DBGSTR1(a,b)
#define DBGSTR2(a,b,c)
#define DBGSTR3(a,b,c,d)
#endif

#define ARRAYSIZE(x) sizeof(x)/sizeof(x[0])
#define MAX_STR 10

// Dialog stuff
TCHAR szComPort[MAX_STR]=_T("COM1:");
int nBaud=115200;
TCHAR szParity[MAX_STR]=_T("None");
int nData=8;
TCHAR szStop[MAX_STR]=_T("1");
TCHAR szFlow[MAX_STR]=_T("None");
TCHAR szIpAddr[80]=_T("127.0.0.1");
//TCHAR szIpAddr[80]="ridgecrop";
int nIpPort=100;

// Coms stuff handles
HANDLE hComPort = INVALID_HANDLE_VALUE;
SOCKET sockSocket;

// Errors
TCHAR szComError[100];
TCHAR szSocketError[100];

// state
BOOL fActive=FALSE;

// Thread handle
HANDLE hThread;
volatile BOOL fKillThread=FALSE;

#define REG_PATH	_T("Software\\Ridgecrop Consultants Ltd\\Netcom")


void RegistryIo ( BOOL fToVars )
{
	HKEY hKey;
	DWORD dwIntSize=sizeof(int);
	DWORD dwSzSize=MAX_STR;

	if ( fToVars )
		{
		if ( RegOpenKey ( HKEY_CURRENT_USER, REG_PATH, &hKey ) != ERROR_SUCCESS )
			{
			return;
			}
		RegQueryValueEx ( hKey, _T("ComPort"), 0, NULL, (LPBYTE) szComPort, &dwSzSize );
		RegQueryValueEx ( hKey, _T("ComBaud"), 0, NULL, (LPBYTE) &nBaud, &dwIntSize );
		RegQueryValueEx ( hKey, _T("ComParity"), 0, NULL, (LPBYTE) szParity, &dwSzSize );
		RegQueryValueEx ( hKey, _T("ComDataBits"), 0, NULL, (LPBYTE) &nData, &dwIntSize );
		RegQueryValueEx ( hKey, _T("ComParity"), 0, NULL, (LPBYTE) szParity, &dwSzSize );
		RegQueryValueEx ( hKey, _T("ComStopBits"), 0, NULL,(LPBYTE) szStop, &dwSzSize );	
		RegQueryValueEx ( hKey, _T("ComFlow"), 0, NULL, (LPBYTE)szFlow, &dwSzSize );			

		RegQueryValueEx ( hKey, _T("IPAddr"), 0, NULL,(LPBYTE) szIpAddr, &dwSzSize );
		RegQueryValueEx ( hKey, _T("IPPort"), 0, NULL,(LPBYTE) &nIpPort, &dwIntSize );

		
		}
	else
		{
		if ( RegOpenKey ( HKEY_CURRENT_USER, REG_PATH, &hKey ) != ERROR_SUCCESS )
			{
			if ( RegCreateKey ( HKEY_CURRENT_USER, REG_PATH, &hKey ) != ERROR_SUCCESS )
				{
				return;
				}
			}

		RegSetValueEx ( hKey, _T("ComPort"), 0, REG_SZ, (CONST BYTE *) szComPort, sizeof(szComPort) );
		RegSetValueEx ( hKey, _T("ComBaud"), 0, REG_DWORD, (CONST BYTE *) &nBaud, sizeof(nBaud) );
		RegSetValueEx ( hKey, _T("ComParity"), 0, REG_SZ, (CONST BYTE *) szParity, sizeof(szParity) );
		RegSetValueEx ( hKey, _T("ComDataBits"), 0, REG_DWORD, (CONST BYTE *) &nData, sizeof(nData) );
		RegSetValueEx ( hKey, _T("ComParity"), 0, REG_SZ, (CONST BYTE *) szParity, sizeof(szParity) );
		RegSetValueEx ( hKey, _T("ComStopBits"), 0, REG_SZ,(CONST BYTE *) szStop, sizeof(szStop) );	
		RegSetValueEx ( hKey, _T("ComFlow"), 0, REG_SZ, (CONST BYTE *)szFlow, sizeof(szFlow) );			

		RegSetValueEx ( hKey, _T("IPAddr"), 0, REG_SZ,(CONST BYTE *) szIpAddr, sizeof(szIpAddr) );
		RegSetValueEx ( hKey, _T("IPPort"), 0, REG_DWORD,(CONST BYTE *) &nIpPort, sizeof(nIpPort) );
		}
	
}


int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	INITCOMMONCONTROLSEX i;
	

#ifdef UNICODE
	// dwVersion has the following format
	// 0:7 = major version
	// 8:15 = minor version
	// 16:30 = build (if NT)
	// Bit 30 is 0 for NT based, 1 for Win9x
	DWORD dwVersion = GetVersion();
	if (  dwVersion & 0x80000000 )
		{
		MessageBoxA ( NULL, "This program requires an OS with Unicode support", "Error", MB_ICONSTOP | MB_OK );
		return(-1);
		}
#endif


	i.dwSize=sizeof(i);
	i.dwICC=ICC_WIN95_CLASSES | ICC_DATE_CLASSES | 
		ICC_USEREX_CLASSES | ICC_COOL_CLASSES | ICC_INTERNET_CLASSES;
	InitCommonControlsEx(&i);

    RegistryIo ( TRUE );

    WSADATA wsaData;
    if ( WSAStartup( 0x202, &wsaData ) != 0 )
        {
        MessageBox ( NULL, _T("WSAStartup failed"), _T("Error"), MB_ICONSTOP | MB_OK );
        WSACleanup();
        return(-1);
        }

    HWND hDialog = 0;
    
	hDialog = CreateDialog (hInstance, 
                            MAKEINTRESOURCE(IDD_DIALOG1), 
                            0, 
                            DialogProc);

    //ShowWindow ( hDialog, nCmdShow );
	
	MSG  msg;
    int status;
    while ((status = GetMessage (& msg, 0, 0, 0)) != 0)
    {
        if (status == -1)
            return -1;
        if (!IsDialogMessage (hDialog, & msg))
        {
            TranslateMessage ( & msg );
            DispatchMessage ( & msg );
        }
    }

    return msg.wParam;

}

BOOL ComboSelectItem ( HWND hwndDlg, int nDlgItem, LPCTSTR szSetString, int nSetItem, BOOL fAdd )
{
	int nIndex;
	TCHAR szString[MAX_STR];

	if ( szSetString )
		wsprintf ( szString, _T("%s"), szSetString );
	else
		wsprintf ( szString, _T("%d"), nSetItem );

	HWND hwndCtl = GetDlgItem( hwndDlg, nDlgItem );

	ComboBox_SetCurSel ( hwndCtl, 0 );
	nIndex=ComboBox_FindStringExact( hwndCtl, 0, szString );
	if ( nIndex != CB_ERR )
		{
		ComboBox_SetCurSel ( hwndCtl, nIndex );
		return(TRUE);
		}

	if ( !fAdd )
		return(FALSE);

	nIndex=ComboBox_AddString ( hwndCtl, szString );
	ComboBox_SetCurSel ( hwndCtl, nIndex );

	return(TRUE);

}


void FillCombo ( HWND hwndDlg, int nDlgItem, const TCHAR arStrings[][MAX_STR], int nCount )
{
	int i;

	HWND hwndCtl = GetDlgItem( hwndDlg, nDlgItem );
	ComboBox_ResetContent ( hwndCtl );
	for ( i=0; i<nCount; i++)
		{
		ComboBox_AddString ( hwndCtl, (LPARAM) arStrings[i] );
		}
						
	ComboBox_SetCurSel ( hwndCtl, 0 );

	
}

void FillCombos ( HWND hwndDlg )
{
static const TCHAR ComPorts[][MAX_STR]=
{
	_T("COM1:"),
	_T("COM2:"),
	_T("COM3:"),
	_T("COM4:"),
	_T("COM5:"),
	_T("COM6:"),
	_T("COM7:"),
	_T("COM8:"),
	_T("COM9:"),
};

static const TCHAR BaudRates[][MAX_STR]=
{
	_T("115200"),
	_T("38400"),
	_T("19200"),
	_T("9600"),
};

static const TCHAR Parities[][MAX_STR]=
{
	_T("None")
	,_T("Odd"),
	_T("Even")
};

static const TCHAR Data[][MAX_STR]=
{
	_T("5"),
	_T("6"),
	_T("7"),
	_T("8")
};

static const TCHAR Stop[][MAX_STR]=
{
	_T("1"),
	_T("1.5"),
	_T("2")
};

static const TCHAR Flow[][MAX_STR]=
{
	_T("Hardware"),
	_T("None"),
	_T("XON/XOFF"),
};

	FillCombo ( hwndDlg, IDC_COMBOPORT, ComPorts, ARRAYSIZE(ComPorts) );
	FillCombo ( hwndDlg, IDC_COMBOBAUD, BaudRates, ARRAYSIZE(BaudRates) );			
	FillCombo ( hwndDlg, IDC_COMBOPARITY, Parities, ARRAYSIZE(Parities) );
	FillCombo ( hwndDlg, IDC_COMBODATA, Data, ARRAYSIZE(Data) );
	FillCombo ( hwndDlg, IDC_COMBOSTOP, Stop, ARRAYSIZE(Stop) );			
	FillCombo ( hwndDlg, IDC_COMBOFLOW, Flow, ARRAYSIZE(Flow) );			
}



BOOL CentreDialog ( HWND hwndDlg )
{
	HWND hwndOwner; 
	RECT rc, rcDlg, rcOwner; 

	// Get the owner window and dialog box rectangles. 
	if ((hwndOwner = GetParent(hwndDlg)) == NULL) 
	{
		hwndOwner = GetDesktopWindow(); 
	}

	GetWindowRect(hwndOwner, &rcOwner); 
	GetWindowRect(hwndDlg, &rcDlg); 
	CopyRect(&rc, &rcOwner); 

	 // Offset the owner and dialog box rectangles so that 
	 // right and bottom values represent the width and 
	 // height, and then offset the owner again to discard 
	 // space taken up by the dialog box. 

	OffsetRect(&rcDlg, -rcDlg.left, -rcDlg.top); 
	OffsetRect(&rc, -rc.left, -rc.top); 
	OffsetRect(&rc, -rcDlg.right, -rcDlg.bottom); 

	 // The new position is the sum of half the remaining 
	 // space and the owner's original position. 
	SetWindowPos(hwndDlg, 
		HWND_TOP, 
		rcOwner.left + (rc.right / 2), 
		rcOwner.top + (rc.bottom / 2), 
		0, 0,          // ignores size arguments 
		SWP_NOSIZE); 

	return(TRUE);
}

BOOL InitSerial ( )
{
	DCB dcb;
	TCHAR modeline[80];
	COMMTIMEOUTS cto_nowait  = { MAXDWORD, 0, 0, 0, 0 };
	enum { NONE, HARDWARE, XON, INVALID } flow=INVALID;

	wsprintf ( modeline, _T("baud=%d parity=%c data=%d stop=%s"), nBaud, szParity[0], nData, szStop );

	wsprintf( szComError,_T("") );

	hComPort = CreateFile ( szComPort, 
	  GENERIC_READ |GENERIC_WRITE, 
	  0, NULL, 
	  OPEN_EXISTING, 0, NULL );

	if ( hComPort==INVALID_HANDLE_VALUE )
		{
		wsprintf( szComError,_T("Failed to open port") );
		return(FALSE);
		}

	dcb.DCBlength = sizeof(dcb);
	GetCommState( hComPort, &dcb );

	BuildCommDCB ( modeline, &dcb );

	if (!_tcscmp(szFlow, _T("Hardware")) )
		{
		flow=HARDWARE;
		}

	if (!_tcscmp(szFlow, _T("None")) )
		{
		flow=NONE;
		}

	if (!_tcscmp(szFlow, _T("XON/OFF")) )
		{
		flow=XON;
		}

	if ( flow==INVALID)
		{
		flow=NONE;
		DBGSTR1("Warning Flow %s is invalid\n", szFlow);
		}

	// Setup for no handshaking
	dcb.fOutxCtsFlow=FALSE;
	dcb.fOutxDsrFlow=FALSE;
	dcb.fDtrControl=DTR_CONTROL_ENABLE;
	dcb.fDsrSensitivity=FALSE;
	dcb.fOutX=FALSE;
	dcb.fInX=FALSE;
	dcb.fRtsControl=RTS_CONTROL_ENABLE;
	dcb.fTXContinueOnXoff =TRUE;

	switch (flow)
	{
		case INVALID:
			DBGSTR1("Warning Flow %s is invalid\n", szFlow);
			// fall through to none
		case NONE:
			break;
		case HARDWARE:
			dcb.fOutxCtsFlow=TRUE;
			dcb.fOutxDsrFlow=TRUE;			
			dcb.fRtsControl=RTS_CONTROL_HANDSHAKE;
			dcb.fDtrControl=DTR_CONTROL_HANDSHAKE;
			break;
		case XON:
			dcb.fOutX=FALSE;
			dcb.fInX=FALSE;
			break;

	}

	if(!SetCommState(hComPort,&dcb))
		{
		wsprintf( szComError,_T("Failed to configure port") );
		return(FALSE);
		}

    
	if(!SetCommTimeouts(hComPort,&cto_nowait))
		{
		wsprintf( szComError,_T("Failed to configure timeouts") );
		return(FALSE);
		}

	PurgeComm ( hComPort, PURGE_TXCLEAR );
	PurgeComm ( hComPort, PURGE_TXABORT );

	// Comm port is open
	wsprintf( szComError,_T("%s open"), szComPort );

	return(TRUE);
}

BOOL InitIP()
{
	
	struct hostent *he;
	struct sockaddr_in addy={0};
	
	unsigned long addr;

#ifdef UNICODE
	char aszIpAddr[MAX_STR];
	WideCharToMultiByte ( CP_ACP, 0, szIpAddr, -1, aszIpAddr, MAX_STR, 0, NULL );
	TCHAR buf[20];
#endif
	
	addr=INADDR_NONE;

	wsprintf( szSocketError,_T("") );
	sockSocket = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);

	if(sockSocket == INVALID_SOCKET )
	{
		wsprintf( szSocketError, _T("Could not create socket") );
		return(FALSE);
	}

#ifndef UNICODE
	addr = inet_addr(szIpAddr);
#else
	addr = inet_addr(aszIpAddr);
#endif
	if ( addr == INADDR_NONE )
		{	
#ifndef UNICODE
		he = gethostbyname(szIpAddr);
#else
		he = gethostbyname(aszIpAddr);
#endif
		if ( he )
			{
			addr = *((u_long*)he->h_addr_list[0]);
			}
		}


	if ( addr == INADDR_NONE )
		{	
		wsprintf( szSocketError, _T("Could not find server %s"),szIpAddr  );
		return(FALSE);
		}

	addy.sin_port=htons(nIpPort);
	addy.sin_family=AF_INET;
	addy.sin_addr.s_addr =addr;
	
	if (connect(sockSocket,(sockaddr*)&addy,sizeof(addy))==SOCKET_ERROR) 
	{
			wsprintf( szSocketError, _T("Could not connect to %s:%d"),szIpAddr, WSAGetLastError() );
			return(FALSE);
	}
	
	IN_ADDR in_addr;
	memcpy( &in_addr, &addr, sizeof(addr) );

#ifndef UNICODE
	wsprintf( szSocketError, _T("Connected to %s:%d"),inet_ntoa(in_addr),nIpPort );
#else
	MultiByteToWideChar( CP_ACP, 0, inet_ntoa(in_addr), -1, buf, ARRAYSIZE(buf) );
	wsprintf( szSocketError, _T("Connected to %s:%d"),buf,nIpPort );
#endif

  int timeout=1;
  int ret;

  ret=setsockopt ( sockSocket, SOL_SOCKET, SO_RCVTIMEO, (const char*)&timeout, sizeof(timeout) );
  
  if (ret)
	{
	DBGSTR2 ( _T("setsockopt returned %d %d\n"), ret, WSAGetLastError() );
	}
	
  return(TRUE);
}

void EnableControls ( HWND hwndDlg, BOOL fEnable )
{
	static int Controls[]={
		IDC_COMBOPORT, IDC_COMBOBAUD, IDC_COMBOPARITY, IDC_COMBODATA, 
		IDC_COMBOSTOP, IDC_COMBOFLOW, IDC_EDITIP, IDC_EDITPORT };

	HWND hwndCtl;
	int i;

	for (i=0; i<ARRAYSIZE(Controls);i++)
		{
		hwndCtl = GetDlgItem( hwndDlg, Controls[i] );
		EnableWindow( hwndCtl, fEnable );
		}

}

void DialogIo ( HWND hwndDlg, BOOL fDialogToVars )
{
	if ( fDialogToVars )
	{
		GetDlgItemText ( hwndDlg, IDC_COMBOPORT, szComPort, MAX_STR );
		nBaud=GetDlgItemInt  ( hwndDlg, IDC_COMBOBAUD, NULL, FALSE );
		GetDlgItemText ( hwndDlg, IDC_COMBOPARITY, szParity, MAX_STR );
		nData=GetDlgItemInt  ( hwndDlg, IDC_COMBODATA, NULL, FALSE );
		GetDlgItemText ( hwndDlg, IDC_COMBOSTOP, szStop, MAX_STR );
		GetDlgItemText ( hwndDlg, IDC_COMBOFLOW, szFlow, MAX_STR );

		GetDlgItemText ( hwndDlg, IDC_EDITIP, szIpAddr, MAX_STR );
		nIpPort=GetDlgItemInt  ( hwndDlg, IDC_EDITPORT, NULL, FALSE );
	}
	else
	{
		ComboSelectItem( hwndDlg, IDC_COMBOPORT, szComPort,0, TRUE );
		ComboSelectItem( hwndDlg, IDC_COMBOBAUD, NULL, nBaud, TRUE );
		ComboSelectItem( hwndDlg, IDC_COMBOPARITY, szParity,0, FALSE );
		ComboSelectItem( hwndDlg, IDC_COMBODATA, NULL, nData, FALSE );
		ComboSelectItem( hwndDlg, IDC_COMBOSTOP, szStop,0, FALSE );
		ComboSelectItem( hwndDlg, IDC_COMBOFLOW, szFlow,0, FALSE );

		SetDlgItemText (hwndDlg, IDC_EDITIP, szIpAddr);
		SetDlgItemInt ( hwndDlg, IDC_EDITPORT, nIpPort, FALSE );

	}
	
}


DWORD WINAPI IoThreadProc( LPVOID lpParameter )
{
	char Buf[80];

	DWORD dwResult=0;
	DWORD dwCount, nCount;

	while(1)
		{
		if ( fKillThread )
			break;

	    if ( ! ReadFile(hComPort,Buf,sizeof(Buf),&dwCount,NULL) )
			{
			dwResult=GetLastError();
			DBGSTR1(_T("Io Error ReadFile %d!\n"), dwResult );
			break;	
			}
		if (dwCount)
			{
			DBGSTR1( _T("Got serial data %d bytes\n"), dwCount );
			send(sockSocket,Buf,dwCount,0);
			}

		if ( fKillThread )
			break;

		nCount = recv(sockSocket, Buf, sizeof(Buf), 0 );
		if (nCount==SOCKET_ERROR)
			{
			dwResult=WSAGetLastError();
			if ( dwResult!=WSAETIMEDOUT )
				{
				DBGSTR1(_T("Io Error recv %d!\n"), dwResult );
				break;	
				}
			else
				{
				nCount=0;
				}
			}	

		if ( nCount )
			{
			DBGSTR1( _T("Got IP data %d bytes\n"), nCount );
			if ( !WriteFile ( hComPort, Buf, nCount, &dwCount, NULL ) )
				{
				dwResult=GetLastError();
				DBGSTR1(_T("Io Error Write %d!\n"), dwResult );
				break;	
				}
			}

		}
	
	return(dwResult);
}


BOOL CALLBACK DialogProc(
  HWND hwndDlg,  // handle to dialog box
  UINT uMsg,     // message
  WPARAM wParam, // first message parameter
  LPARAM lParam  // second message parameter
)
{
	
    switch (uMsg) 
    { 

	    case WM_INITDIALOG: 

			CentreDialog( hwndDlg );
		
			FillCombos ( hwndDlg  );
			
			DialogIo( hwndDlg, FALSE);
			return(FALSE);

		case WM_COMMAND: 
			
            DBGSTR3 ( _T("WM_COMMAND lParam=%d, HIWORD(wParam)=%d LOWORD(wParam)=%d\n"), lParam, HIWORD(wParam), LOWORD(wParam) );
			
			switch (LOWORD(wParam)) 
            { 
				case IDC_BTNACTIVATE:
					
					if ( ! fActive )
						{
						DialogIo( hwndDlg, TRUE);

						BOOL fSerialOk, fIPOk;

						fSerialOk=InitSerial();
						fIPOk=InitIP();

						if ( fSerialOk && fIPOk )
							{

							EnableControls ( hwndDlg, FALSE);
							fKillThread=FALSE;
							DWORD dwThread;
							hThread = CreateThread ( NULL, // Security
									0, // stack
									IoThreadProc,
									NULL, // param
									0, // flags
									&dwThread);
							DBGSTR2( _T("hThread=%d, id=%x\n"), hThread, dwThread );

					
							SetDlgItemText ( hwndDlg, IDC_BTNACTIVATE, _T("Deactivate") );	
							fActive=TRUE;
							}
						else
							{
							// something went wrong, display errors and clean up
							if ( fSerialOk )
								{
								wsprintf( szComError,_T("") );
								}
							if ( fIPOk)
								{
								wsprintf( szSocketError,_T("") );
								}
							
							CloseHandle(hComPort);
							shutdown(sockSocket, SD_BOTH );
							closesocket(sockSocket);
							}
						SetDlgItemText ( hwndDlg, IDC_STATICCOMSTAT, szComError );	
						SetDlgItemText ( hwndDlg, IDC_STATICIPSTAT, szSocketError );											
						}
					else
						{	
						fKillThread=TRUE;
						WaitForSingleObject( hThread, 1000);
						// debug
						CloseHandle(hComPort);
						shutdown(sockSocket, SD_BOTH );
						closesocket(sockSocket);
						SetDlgItemText ( hwndDlg, IDC_BTNACTIVATE, _T("Activate") );	
						EnableControls ( hwndDlg, TRUE);
						fActive=FALSE;
						SetDlgItemText ( hwndDlg, IDC_STATICCOMSTAT, _T("") );	
						SetDlgItemText ( hwndDlg, IDC_STATICIPSTAT, _T("") );	
						}

					return(TRUE);

				case IDOK: 	
					DialogIo( hwndDlg, TRUE);
					RegistryIo ( FALSE );
				case IDCANCEL: 
					DestroyWindow(hwndDlg);
                return TRUE; 

				default:
					return FALSE;
            } 

		case WM_DESTROY:
			PostQuitMessage(0);
			return(0);

			
    } 
    return FALSE; 

}

